﻿using nft.framework;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace nft.framework.repository
{
    public class DefaultRepositoryBuilder<T,U> : IRepositoryBuilder<T> where T: class, IHasNameAndID where U: IRepository<T>
    {
        protected Dictionary<string, T> dictionary = new Dictionary<string, T>();

        public void Add(T model)
        {
            dictionary.Add(model.ID, model);
        }

        public T RemoveByID(string id)
        {
            T ret;
            if (!dictionary.TryGetValue(id, out ret)) {
                ret = null;
            }            
            dictionary.Remove(id);
            return ret;
        }

        public IRepository<T> Finalize()
        {
            Type[] types = { typeof(IDictionary<string, T>) };
            ConstructorInfo ci = typeof(U).GetConstructor(types);
            object[] args = { this.dictionary };
            U repository = (U) ci.Invoke( args );
            return repository;
        }
    }
}
