﻿using nft.framework;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace nft.framework.repository
{
    public class RepositoryBase<T> : IRepository<T> where T: class, IHasNameAndID
    {
        protected Dictionary<string, T> dictionary = new Dictionary<string, T>();

        public T this[string id]
        {
            get
            {
                T ret;
                if( dictionary.TryGetValue(id, out ret) ) return ret;
                return null;
            }
        }

        public int Count
        {
            get
            {
                return dictionary.Count;
            }
        }

        public IEnumerable<T> List
        {
            get
            {
                return dictionary.Values;
            }
        }

        public void Add(T model)
        {
            dictionary.Add(model.ID, model);
        }

        public T RemoveByID(string id)
        {
            T ret = this[id];
            dictionary.Remove(id);
            return ret;
        }
    }
}
